# Integer class method overloading.
class Integer
  # Returns the biggest prime factor
  # https://en.wikipedia.org/wiki/Prime_factor
  #
  # By the fundamental theorem of arithmetic,
  # every integer n > 1 has a unique factorization of prime numbers.
  #
  # n = P1 * P2 * P3 * ... * P(M-1) w/ P(i) > 1 and prime.
  # If we divide n by its smallest prime factor,
  # the last one will be the biggest.
  #
  def biggest_prime_factor
    number = self
    while (factor = number.smallest_prime_factor) < number
      number /= factor
    end
    number
  end
end