# Integer class method overloading.
class Integer
  # Returns the smallest prime factor
  # https://en.wikipedia.org/wiki/Prime_factor
  #
  # The least prime factor is the least factor,
  # as if the least factor was a composite number,
  # the least prime factor would divide the original number.
  #
  def smallest_prime_factor
    raise 'Number is less than 2' unless self >= 2
    (2..Math.sqrt(self)).map do |number|
      return number if number.factor_of?(self)
    end
    self
  end
end